from datetime import datetime as dt

t1 = dt.now()

def convert(pattern, m):
    p = ''
    for i in range(m):
        if pattern[i] == 'A': p += '1'
        if pattern[i] == 'C': p += '2'
        if pattern[i] == 'G': p += '3'
        if pattern[i] == 'T': p += '4'
        if pattern[i] == '\n': p += '5'
    p = int(p)
    return p

def Next(frame, text, i, m):
    frame = (frame%10**(m-1))*10 + convert(text[i+m],1)
    return frame

def RabKa(pattern,text):
    t = convert(text,lp)
    p = convert(pattern,lp)
    m = len(str(t)) 
    for i in range(len(text)-len(pattern)):
        if p==t:
            print 'FOUND', i
            return i
            break
        else:
            t= Next(t,text,i,m)
    
text1 = open('TAF5.txt')
text = text1.read()
text1.close()
pattern = 'CCTTTCCAGGTTCCTTT'
lp = len(pattern)

RabKa(pattern,text)

t2 = dt.now()
print 'RabKarp', t2-t1, '\n'

#-----------------------------------------------------

t1 = dt.now()

def Naive(pattern, text):
    lp = len(pattern)
    lt = len(text)
    i = 0
    while i < lt:
        j = 0
        while j < lp and pattern[j] == text[i+j]:
            j += 1
        if j == lp:
            print '\nFOUND', i
            return i
        i += 1
    return -1

text1 = open('TAF5.txt')
text = text1.read()
text1.close()
pattern = 'CCTTTCCAGGTTCCTTT'
Naive(pattern, text)

t2 = dt.now()
print 'Naive', t2-t1, '\n'


#-----------------------------------------------------

t1 = dt.now()

def sp(p):
    sp = [-1,0]
    for i in range(2,len(p)):
        if p[i-1] == p[sp[i-1]]:
            sp.append(sp[i-1]+1)
        else:
            j = i-1
            while sp[j] != -1:
                if p[sp[j]] == p[i-1]:
                    sp.append(sp[j]+1)
                    break
                else:
                    j = sp[j]
            else: sp.append(0)
    return sp

def KMP(p,t):
    SP = sp(p)
    #print sp
    lp = len(p)
    lt = len(t)
#j is the element in text you start new comparisson with
    j = 0
#m is the number of matches between pattern and current text sample
    m = 0
    while j < (lt-lp):
#i is the letter in text you are to compare w.pattern    
        i = j
        while p[m]==t[i]:
            m+=1
            i+=1
            if lp==i-j:
                print 'FOUND', j
                return j
                break
        if lp==i-j:
            break
        #j = i-SP[i]
        j += m-SP[m]
        if m==0:
            m = 0
        else:
            m = SP[m]
    
text = open('TAF5.txt')
t = text.read()
text.close()
p = 'CCTTTCCAGGTTCCTTT'
KMP(p,t)
    
t2 = dt.now()
print 'KMP', t2-t1, '\n'